/*

Scrivere un programma per la gestione dei libri e dei prestiti di una biblioteca universitaria. 
I libri sono caratterizzati dalle seguenti informazioni: titolo, autore, collocazione del libro, numero di copie,  genere del libro.
I libri sono inseriti in una tabella allocata dinamicamente avente 5 righe, una per ogni genere di libro. 
Per quanto riguarda i prestiti, essi sono caratterizzati dalle seguenti informazioni: matricola dello studente, collocazione del libro, giorno del prestito, corso di laurea. 
Ogni nuovo prestito viene inserito in un vettore di 4 liste, una per ogni corso di laurea. 
L'inserimento nella lista relativa al corso di laurea viene eseguito solo dopo avere verificato la presenza del libro.
Ogni lista  ordinata rispetto alla matricola.
Nel programma  presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento di un nuovo libro; 
2.	Visualizzazione dei libri relativi a un certo genere;
3.	Inserimento ordinato di un prestito nella lista relativa al corso di laurea dopo averne verificato la presenza nella tabella;
4.	Visualizzazione dei prestiti relativi agli studenti appartenenti a un certo corso di laurea.
5.	Salvataggio su file del contenuto del contenuto della tabella.

All'avvio del programma i libri precedentemente salvati su file devono essere letti e copiati nella tabella mediante una funzione di inizializzazione della tabella. 

Liberare la memoria allocata dinamicamente.
*/


#include <stdio.h>
#include <stdlib.h>

typedef struct {
        char titolo[80];
        char autore[80];
        int collocazione;
        int ncopie;
        int genere;
} libro;

typedef struct {
        long matricola;
        int collocazione,corso;
        char data[12];
        } prestito;
        
struct atomo {
       prestito dato;
       struct atomo *next;
       };
void leggi_libro(libro *l);       
void ins_libro(libro *T[5], int N[5], libro l);
void visualizza_libri(libro *T[5], int N[5]);
int ricerca(libro R[], int n, int collocazione);
void leggi(prestito *p);
void ins_ordinato(struct atomo **tl, prestito p);
void visualizza_prestiti(struct atomo *tl);
void salva(libro *T[5], int N[5]);
void inizializza(libro *T[5], int N[5]);
void da_lista(struct atomo **tl);

main() {
       libro *T[5], l;
       int N[5];
       struct atomo *LV[4];
       int i,col;
       prestito p;
       int op;
       
       
       /* inizializzazione */
         for(i=0;i<5;i++)
           {T[i]=NULL;
            N[i]=0;
            }
            
         for(i=0;i<4;i++)
           LV[i]=NULL;
           
         inizializza(T,N);
         
         
         do {
             printf("\nScegli quale operazione eseguire\n");
             printf("1) Ins. libro\n2) Visualizzazione libri\n");
             printf("3) Ins. prestito\n4) Visualizzazione prestiti\n");
             printf("5) Salvataggio su file\n");
             printf("0) fine\n");
             scanf("%d",&op);
             switch(op) {
               case 1:   /* ins. libro */  
                         leggi_libro(&l);
                         ins_libro(T,N,l);
                         break;
               case 2:  /* visualizzazione per genere*/
                        visualizza_libri(T,N);
                        break;
               case 3:  /* inserimento prestito dopo verifica*/
                        leggi(&p);
                        printf("Genere libro ");
                        scanf("%d",&i);
                        col=p.collocazione;
                        if(ricerca(T[i],N[i],col)==1)
                          /* se il libro e' presente*/
                          ins_ordinato(&LV[p.corso], p);
                        else printf("Libro non presente\n");
                        break;
             case 4:  /* visualizzazione prestiti per corso di laurea*/
                         printf("Corso di laurea (0..3) ");
                         scanf("%d",&i);
                         visualizza_prestiti(LV[i]);
                         break;
               case 5:  /* salvataggio su file */
                        salva(T,N);
                        break;
               default:; }
               }  while(op!=0);
               
               /* liberiamo la memoria */
               for(i=0;i<5;i++)
                 free(T[i]);
                 
            for(i=0;i<4;i++)
                 while(LV[i]!=NULL)
                  /* fino a quando la lista LV[i] non e' vuota */
                  da_lista(&LV[i]);
                   
}  

void leggi_libro(libro *l)
{
  /* lettura libro da inserire */
     printf("Titolo: ");
     fflush(stdin);
     gets(l->titolo);
     printf("Autore: ");
     gets(l->autore);
     printf("Collocazione: ");
     scanf("%d",&l->collocazione);
     printf("Num. copie: ");
     scanf("%d",&l->ncopie);
     printf("Genere: (0..4) ");
     scanf("%d",&l->genere);
}               
void ins_libro (libro *T[5], int N[5], libro l)
{
     
     libro *aux;
     int i;
     
     
     i=l.genere;
     aux=(libro *) realloc(T[i],sizeof(libro)*(N[i]+1));
     if (aux==NULL)
          return;
     T[i]=aux;
     T[i][N[i]]=l;
     N[i]++;
}
void visualizza_libri(libro *T[5], int N[5])
{
     int i,j;
     
     printf("Genere: ");
     scanf("%d",&i);
     
     for(j=0;j<N[i];j++)
       {
         printf("Titolo: %s\n",T[i][j].titolo);
         printf("Collocazione: %d\n\n",T[i][j].collocazione);
       }
}

void leggi (prestito *p)
{
     printf("Matricola: ");
     scanf("%ld",&p->matricola);
     printf("Collocazione: ");
     scanf("%d",&p->collocazione);
     printf("Data prestito: ");
     scanf("%s",p->data);
     printf("Corso di laurea (0..3) ");
     scanf("%d",&p->corso);
}

int ricerca(libro R[], int n, int collocazione)
{
    int i;
    
    for(i=0;i<n;i++)
      if(R[i].collocazione==collocazione)
        return 1;
  
    /* se si arriva in questo punto l'elemento non e' presente*/
     return 0;
}

void ins_ordinato(struct atomo **tl, prestito p)
{
  struct atomo *aux;
  
  if(*tl==NULL || p.matricola < (*tl)->dato.matricola)
   /* inserimento in testa */
   {  aux=(struct atomo *) malloc(sizeof(struct atomo));
      if(aux==NULL) return;
      aux->dato=p;
      aux->next=*tl;
      *tl=aux;
      return;
   }
   ins_ordinato(&(*tl)->next,p);
}

void visualizza_prestiti(struct atomo *tl)
{
     
     while(tl!=NULL)
      {  printf("matricola: %ld\n",tl->dato.matricola);
         printf("Data: %s\n",tl->dato.data);
         tl=tl->next;
         }
}

void salva(libro *T[5], int N[5])
{
     FILE *pf;
     
     libro l;
     int i,j;
     
     pf=fopen("libri.lib", "w");
     if(pf) {
              for(i=0;i<4;i++)
                for(j=0;j<N[i];j++)
                 { l=T[i][j];
                   fwrite(&l,sizeof(libro),1,pf);
                 } 
               
               fclose(pf);
            }
}
               
                    
void inizializza(libro *T[5], int N[5])
{
     FILE *pf;
     libro l;
     int i;
     
     pf=fopen("libri.lib", "r");
     if(pf) {
              while(fread(&l,sizeof(libro),1,pf)!=0)
                                  
                  ins_libro(T,N,l);
                  
              fclose(pf);
              }
}
                
     
void da_lista(struct atomo **tl)
{
     struct atomo *a;
     
     a=*tl;
     *tl=a->next;
     free(a);
}

  
    
